## libthread-pool 1.0.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.2)
project(thread_pool)

set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/lib)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/lib)
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/bin)

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra -pedantic -march=native")
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

option(thread_pool_build_tests "Build thread_pool unit tests" OFF)

add_library(thread_pool STATIC
    src/thread_pool.cpp)

target_include_directories(thread_pool PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:include>)

install(TARGETS thread_pool DESTINATION lib)
install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/include/thread_pool DESTINATION include)

if (thread_pool_build_tests)
    add_executable(thread_pool_test test/thread_pool_test.cpp)
    add_subdirectory(vendor/googletest/googletest EXCLUDE_FROM_ALL)
    target_link_libraries(thread_pool_test thread_pool gtest_main)
endif(thread_pool_build_tests)

=== debian/changelog ===
libthread-pool (1.0.0-2) unstable; urgency=medium

  * Do not build with -march=native
    Closes: #906618
  * Standards-Version: 4.2.0

 -- Andreas Tille <tille@debian.org>  Sun, 26 Aug 2018 14:56:11 +0200

libthread-pool (1.0.0-1) unstable; urgency=medium

  * Initial release (Closes: #901207)

 -- Andreas Tille <tille@debian.org>  Sun, 10 Jun 2018 09:44:39 +0200

=== debian/control ===
Source: libthread-pool
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Andreas Tille <tille@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper (>= 11~),
               cmake,
               d-shlibs,
               rename,
               libgtest-dev
Standards-Version: 4.2.0
Vcs-Browser: https://salsa.debian.org/med-team/libthread-pool
Vcs-Git: https://salsa.debian.org/med-team/libthread-pool.git
Homepage: https://github.com/rvaser/libthread-pool

Package: libthread-pool0
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: C++ thread pool library
 A thread pool is a software design pattern for achieving concurrency of
 execution in a computer program. Often also called a replicated workers
 or worker-crew model,[1] a thread pool maintains multiple threads
 waiting for tasks to be allocated for concurrent execution by the
 supervising program.
 .
 This package contains a shared library with a thread pool
 implementation.

Package: libthread-pool-dev
Architecture: any
Section: libdevel
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libthread-pool0 (= ${binary:Version})
Description: C++ thread pool library (devel)
 A thread pool is a software design pattern for achieving concurrency of
 execution in a computer program. Often also called a replicated workers
 or worker-crew model,[1] a thread pool maintains multiple threads
 waiting for tasks to be allocated for concurrent execution by the
 supervising program.
 .
 This package contains the static library and the header files.

=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE := 1

export DEB_BUILD_MAINT_OPTIONS=hardening=+all


%:
	dh $@

override_dh_install:
	dh_install
	file-rename 's/_static\.a/.a/' `find debian -name "lib*_static.a"`
	d-shlibmove --commit \
		    --multiarch \
		    --devunversioned \
		    --exclude-la \
		    --movedev debian/tmp/usr/include/* usr/include \
		    debian/tmp/usr/lib/*.so

## libthread-pool 2.0.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.2)
project(thread_pool)

include(GNUInstallDirs)

set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/lib)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/lib)
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/bin)

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra -pedantic -march=native")
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)
set(THREADS_PREFER_PTHREAD_FLAG ON)

find_package(Threads REQUIRED)

option(thread_pool_build_tests "Build thread_pool unit tests" OFF)

add_library(thread_pool STATIC
    src/thread_pool.cpp)

target_link_libraries(thread_pool Threads::Threads)

target_include_directories(thread_pool PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:include>)

install(TARGETS thread_pool DESTINATION ${CMAKE_INSTALL_LIBDIR})
install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/include/thread_pool DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

if (thread_pool_build_tests)
    add_executable(thread_pool_test test/thread_pool_test.cpp)

    if (NOT TARGET gtest_main)
        add_subdirectory(vendor/googletest/googletest EXCLUDE_FROM_ALL)
    endif()

    target_link_libraries(thread_pool_test thread_pool gtest_main)
endif()

=== debian/changelog ===
libthread-pool (2.0.1-4build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 23 Mar 2020 07:18:33 +0100

libthread-pool (2.0.1-4) unstable; urgency=medium

  * Test-Depends: build-essential

 -- Andreas Tille <tille@debian.org>  Tue, 19 Nov 2019 21:52:39 +0100

libthread-pool (2.0.1-3) unstable; urgency=medium

  * Test-Depends: cmake

 -- Andreas Tille <tille@debian.org>  Tue, 19 Nov 2019 07:13:35 +0100

libthread-pool (2.0.1-2) unstable; urgency=medium

  * Fix build on i386
  * Provide symbols for amd64 only
  * Standards-Version: 4.4.1
  * Set upstream metadata fields: Repository.

 -- Andreas Tille <tille@debian.org>  Mon, 18 Nov 2019 18:46:39 +0100

libthread-pool (2.0.1-1) unstable; urgency=medium

  * New upstream version

 -- Andreas Tille <tille@debian.org>  Tue, 17 Sep 2019 22:18:26 +0200

libthread-pool (1.0.0-4) unstable; urgency=medium

  [ Helmut Grohne ]
  * Fix FTBFS with nocheck profile: Unconditionally build-depend on
    googletest. (Closes: #939519)

  [ Andreas Tille ]
  * Remove obsolete fields Name from debian/upstream/metadata.

 -- Andreas Tille <tille@debian.org>  Mon, 09 Sep 2019 13:58:23 +0200

libthread-pool (1.0.0-3) unstable; urgency=medium

  [ Michael R. Crusoe ]
  * Add missing '-pthread'
  * Remove trailing whitespace in debian/copyright
  * Update homepage URL.
  * Build the included tests and run them
  * As an autopkgtest, build the tests against the installed package and run
    them.

  [ Andreas Tille ]
  * Rebuild for new version of gcc to fix symbols
    Closes: #925761
  * debhelper-compat 12
  * Standards-Version: 4.4.0
  * Set upstream metadata fields: Name.

 -- Andreas Tille <tille@debian.org>  Wed, 21 Aug 2019 11:19:44 +0200

=== debian/control ===
--- 
+++ 
@@ -3,15 +3,15 @@
 Uploaders: Andreas Tille <tille@debian.org>
 Section: science
 Priority: optional
-Build-Depends: debhelper (>= 11~),
+Build-Depends: debhelper-compat (= 12),
                cmake,
                d-shlibs,
                rename,
-               libgtest-dev
-Standards-Version: 4.2.0
+               googletest
+Standards-Version: 4.4.1
 Vcs-Browser: https://salsa.debian.org/med-team/libthread-pool
 Vcs-Git: https://salsa.debian.org/med-team/libthread-pool.git
-Homepage: https://github.com/rvaser/libthread-pool
+Homepage: https://github.com/rvaser/thread_pool
 
 Package: libthread-pool0
 Architecture: any
@@ -31,8 +31,7 @@
 Package: libthread-pool-dev
 Architecture: any
 Section: libdevel
-Depends: ${shlibs:Depends},
-         ${misc:Depends},
+Depends: ${misc:Depends},
          libthread-pool0 (= ${binary:Version})
 Description: C++ thread pool library (devel)
  A thread pool is a software design pattern for achieving concurrency of

=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE := 1

export DEB_BUILD_MAINT_OPTIONS=hardening=+all
export DEB_LDFLAGS_MAINT_APPEND+=-pthread

%:
	dh $@

override_dh_auto_configure:
	rm -Rf vendor/*
	ln -s /usr/src/googletest ./vendor/
	dh_auto_configure -- -Dthread_pool_build_tests=ON

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	./obj-*/bin/thread_pool_test
endif

override_dh_install:
	dh_install
	file-rename 's/_static\.a/.a/' `find debian -name "lib*_static.a"`
	mv debian/tmp/usr/lib/*.a debian/tmp/usr/lib/`dpkg-architecture -qDEB_HOST_MULTIARCH` # this somehow inserts i686-linux-gnu which is wrong: $(DEB_HOST_MULTIARCH)
	d-shlibmove --commit \
		    --multiarch \
		    --devunversioned \
		    --exclude-la \
		    --movedev debian/tmp/usr/include/* usr/include \
		    debian/tmp/usr/lib/*/*.so

=== debian/watch ===
version=4

https://github.com/rvaser/thread_pool/releases .*/archive/@ANY_VERSION@@ARCHIVE_EXT@

## libthread-pool 2.0.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -7,7 +7,7 @@
 set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/lib)
 set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/bin)
 
-set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra -pedantic -march=native")
+set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra -pedantic")
 set(CMAKE_CXX_STANDARD 11)
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
 set(CMAKE_CXX_EXTENSIONS OFF)

=== debian/changelog ===
libthread-pool (2.0.2-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
  * Standards-Version: 4.5.0 (routine-update)
  * removed "no -marchive" patch that was adopted upstream

 -- Steffen Moeller <moeller@debian.org>  Thu, 30 Apr 2020 22:33:29 +0200

=== debian/control ===
--- 
+++ 
@@ -8,7 +8,7 @@
                d-shlibs,
                rename,
                googletest
-Standards-Version: 4.4.1
+Standards-Version: 4.5.0
 Vcs-Browser: https://salsa.debian.org/med-team/libthread-pool
 Vcs-Git: https://salsa.debian.org/med-team/libthread-pool.git
 Homepage: https://github.com/rvaser/thread_pool

## libthread-pool 3.0.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.9)

project(thread_pool VERSION 3.0.2
                    LANGUAGES CXX
                    DESCRIPTION "ThreadPool is a c++ header only library modifying and extending https://github.com/progschj/ThreadPool.")

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra -pedantic")
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)
set(THREADS_PREFER_PTHREAD_FLAG ON)

set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/lib)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/lib)
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/bin)

find_package(Threads REQUIRED)
add_library(${PROJECT_NAME} INTERFACE)
target_link_libraries(${PROJECT_NAME} INTERFACE
  Threads::Threads)

target_include_directories(${PROJECT_NAME} INTERFACE
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>)

option(thread_pool_build_tests "Build thread_pool unit tests" OFF)
if (thread_pool_build_tests)
  find_package(GTest REQUIRED)
  add_executable(${PROJECT_NAME}_test
    test/semaphore_test.cpp
    test/thread_pool_test.cpp)
  target_link_libraries(${PROJECT_NAME}_test
    ${PROJECT_NAME}
    GTest::Main)
endif ()

=== debian/changelog ===
libthread-pool (3.0.2-1) unstable; urgency=medium

  * Team upload.
  * debian/watch: Uniquely rename the archives download from GitHub.
  * Standards-Version: 4.5.1 (routine-update)
  * debhelper-compat 13 (routine-update)
  * Library is header-only now.
  * Add salsa-ci file (routine-update)
  * Rules-Requires-Root: no (routine-update)
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository-Browse.
  * debian/rules: no more vendor directory
  * build-dep on libgtest-dev so that cmake can find it

 -- Michael R. Crusoe <crusoe@debian.org>  Mon, 18 Jan 2021 16:58:37 +0100

=== debian/control ===
Source: libthread-pool
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Andreas Tille <tille@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               cmake,
               d-shlibs,
               rename,
               libgtest-dev
Standards-Version: 4.5.1
Vcs-Browser: https://salsa.debian.org/med-team/libthread-pool
Vcs-Git: https://salsa.debian.org/med-team/libthread-pool.git
Homepage: https://github.com/rvaser/thread_pool
Rules-Requires-Root: no

Package: libthread-pool-dev
Architecture: all
Section: libdevel
Depends: ${misc:Depends}
Description: C++ header-only thread pool library (devel)
 A thread pool is a software design pattern for achieving concurrency of
 execution in a computer program. Often also called a replicated workers
 or worker-crew model,[1] a thread pool maintains multiple threads
 waiting for tasks to be allocated for concurrent execution by the
 supervising program.

=== debian/watch ===
version=4

opts="filenamemangle=s%(?:.*?)?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
  https://github.com/rvaser/thread_pool/releases .*/@ANY_VERSION@\.tar\.gz

## libthread-pool 4.0.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.11)

project(thread_pool VERSION 4.0.0
                    LANGUAGES CXX
                    DESCRIPTION "ThreadPool is a c++ header only library combining https://github.com/progschj/ThreadPool and task stealing by Sean Parent.")

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra -pedantic")
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)
set(THREADS_PREFER_PTHREAD_FLAG ON)

set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/lib)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/lib)
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/bin)

if (CMAKE_SOURCE_DIR STREQUAL PROJECT_SOURCE_DIR)
  set(thread_pool_main_project ON)
endif ()
option(thread_pool_install "Generate install target" ${thread_pool_main_project})
option(thread_pool_build_tests "Build unit tests" ${thread_pool_main_project})

find_package(Threads REQUIRED)

if (thread_pool_build_tests)
  find_package(GTest 1.10.0 QUIET)
  if (NOT GTest_FOUND)
    include(FetchContent)

    FetchContent_Declare(
      googletest
      GIT_REPOSITORY https://github.com/google/googletest
      GIT_TAG release-1.10.0)

    FetchContent_GetProperties(googletest)
    if (NOT googletest_POPULATED)
      FetchContent_Populate(googletest)
      add_subdirectory(
        ${googletest_SOURCE_DIR}
        ${googletest_BINARY_DIR}
        EXCLUDE_FROM_ALL)
      add_library(GTest::Main ALIAS gtest_main)
    endif ()
  endif ()
endif ()

add_library(thread_pool INTERFACE)
add_library(${PROJECT_NAME}::thread_pool ALIAS thread_pool)

target_include_directories(thread_pool INTERFACE
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
  $<INSTALL_INTERFACE:include>)

target_link_libraries(thread_pool INTERFACE
  Threads::Threads)

if (thread_pool_install)
  include(GNUInstallDirs)
  include(CMakePackageConfigHelpers)

  configure_package_config_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/Config.cmake.in
    ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}Config.cmake
    INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME})
  write_basic_package_version_file(
    ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}ConfigVersion.cmake
    COMPATIBILITY SameMajorVersion)

  install(
    TARGETS thread_pool
    EXPORT ${PROJECT_NAME}Targets)
  install(
    DIRECTORY include/thread_pool
    DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
  install(
    EXPORT ${PROJECT_NAME}Targets
    NAMESPACE ${PROJECT_NAME}::
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME})
  install(
    FILES ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}Config.cmake
          ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}ConfigVersion.cmake
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME})
endif ()

if (thread_pool_build_tests)
  add_executable(thread_pool_test
    test/thread_pool_test.cpp)

  target_link_libraries(thread_pool_test
    thread_pool
    GTest::Main)
endif ()

=== debian/changelog ===
libthread-pool (4.0.0-3) unstable; urgency=medium

  * Team upload.
  * d/t/CMakeLists.txt: bump cmake required to 3.10. (Closes: #1116510)
  * d/watch: convert to v5 Github template.
  * d/control: declare compliance to standards version 4.7.2.
  * d/control: drop redundant Rules-Requires-Root: no.

 -- Étienne Mollier <emollier@debian.org>  Wed, 15 Oct 2025 22:16:59 +0200

libthread-pool (4.0.0-2) unstable; urgency=medium

  * Upload to unstable
  * Standards-Version: 4.6.2 (routine-update)

 -- Andreas Tille <tille@debian.org>  Tue, 13 Feb 2024 08:13:54 +0100

libthread-pool (4.0.0-2~exp) experimental; urgency=medium

  [ Vladimir Petko ]
  * Use size_t type for max() comparison
    Closes: #1032532 (LP: #2009537)

 -- Andreas Tille <tille@debian.org>  Thu, 09 Mar 2023 11:14:22 +0100

libthread-pool (4.0.0-1) unstable; urgency=medium

  [ Nilesh Patra ]
  * New upstream version 4.0.0
  * d/control: Change architecture to any, since
    it now installs arch-dependent .cmake files

  [ Andreas Tille ]
  * Standards-Version: 4.6.1 (routine-update)
  * Fix watch file
  * Remove trailing whitespace in debian/changelog (routine-update)
  * Remove Multi-Arch: foreign

 -- Andreas Tille <tille@debian.org>  Thu, 29 Sep 2022 14:31:47 +0200

=== debian/control ===
--- 
+++ 
@@ -8,19 +8,18 @@
                d-shlibs,
                rename,
                libgtest-dev
-Standards-Version: 4.5.1
+Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/med-team/libthread-pool
 Vcs-Git: https://salsa.debian.org/med-team/libthread-pool.git
 Homepage: https://github.com/rvaser/thread_pool
-Rules-Requires-Root: no
 
 Package: libthread-pool-dev
-Architecture: all
+Architecture: any
 Section: libdevel
 Depends: ${misc:Depends}
 Description: C++ header-only thread pool library (devel)
  A thread pool is a software design pattern for achieving concurrency of
  execution in a computer program. Often also called a replicated workers
- or worker-crew model,[1] a thread pool maintains multiple threads
+ or worker-crew model, a thread pool maintains multiple threads
  waiting for tasks to be allocated for concurrent execution by the
  supervising program.

=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE := 1

export DEB_BUILD_MAINT_OPTIONS=hardening=+all
export DEB_LDFLAGS_MAINT_APPEND+=-pthread

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -Dthread_pool_build_tests=ON

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	./obj-*/bin/thread_pool_test
endif

=== debian/watch ===
Version: 5

Template: Github
Owner: rvaser
Project: thread_pool
